/*
 * Created on 2004/05/24
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package matrix;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractCopyBehavior
*/
public abstract class AbstractCopyBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState bĂ = factory.createCompositeState("bĂ");
		CompositeState neoTĂ = factory.createCompositeState("NeoTĂ");
		CompositeState 퓬P = factory.createCompositeState("퓬P");
		CompositeState S = factory.createCompositeState("S");
		State terminalState = factory.createTerminalState();

		//actions
		Action beginButtle = new Action() {
			public void doAction() {
				beginButtle();
			}
			public String toString() {
				return "beginButtle";
			}
		};
		Action doConversation = new Action() {
			public void doAction() {
				doConversation();
			}
			public String toString() {
				return "doConversation";
			}
		};
		Action beginConversation = new Action() {
			public void doAction() {
				beginConversation();
			}
			public String toString() {
				return "beginConversation";
			}
		};
		Action showResult = new Action() {
			public void doAction() {
				showResult();
			}
			public String toString() {
				return "showResult";
			}
		};
		Action doButtle = new Action() {
			public void doAction() {
				doButtle();
			}
			public String toString() {
				return "doButtle";
			}
		};

		//guard-conditions
		GuardCondition isNotButtleState = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isNotButtleState(e);
			}
		};
		GuardCondition isEndInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isEndInformation(e);
			}
		};
		GuardCondition isDead = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isDead(e);
			}
		};
		GuardCondition isNotDead = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isNotDead(e);
			}
		};

		//transitions
		Transition transition퓬PToS = factory.createTransition();
		Transition transitionbĂTo퓬P = factory.createTransition();
		Transition transitionbĂTobĂ = factory.createTransition();
		Transition transitionSToTerminalState = factory.createTransition();
		Transition transitionNeoTĂTobĂ = factory.createTransition();
		Transition transition퓬PTo퓬P = factory.createTransition();
		Transition transitionInitialStateToNeoTĂ =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(bĂ);
		this.addState(neoTĂ);
		this.addState(퓬P);
		this.addState(S);
		this.addTerminalState(terminalState);

		//transitions setting
		transition퓬PToS.setEvent(ChannelEvent.class);
		transition퓬PToS.setGuardCondition(isDead);
		transitionbĂTo퓬P.setEvent(ChannelEvent.class);
		transitionbĂTo퓬P.setGuardCondition(isEndInformation);
		transitionbĂTo퓬P.addAction(beginButtle);
		transitionbĂTobĂ.setEvent(ChannelEvent.class);
		transitionbĂTobĂ.setGuardCondition(isNotButtleState);
		transitionbĂTobĂ.addAction(doConversation);
		transitionSToTerminalState.addAction(showResult);
		transitionNeoTĂTobĂ.setEvent(TimeEvent.class);
		transitionNeoTĂTobĂ.addAction(beginConversation);
		transition퓬PTo퓬P.setEvent(ChannelEvent.class);
		transition퓬PTo퓬P.setGuardCondition(isNotDead);
		transition퓬PTo퓬P.addAction(doButtle);

		//connection of transitions
		transition퓬PToS.setSourceState(퓬P);
		transition퓬PToS.setTargetState(S);
		transitionbĂTo퓬P.setSourceState(bĂ);
		transitionbĂTo퓬P.setTargetState(퓬P);
		transitionbĂTobĂ.setSourceState(bĂ);
		transitionbĂTobĂ.setTargetState(bĂ);
		transitionSToTerminalState.setSourceState(S);
		transitionSToTerminalState.setTargetState(terminalState);
		transitionNeoTĂTobĂ.setSourceState(neoTĂ);
		transitionNeoTĂTobĂ.setTargetState(bĂ);
		transition퓬PTo퓬P.setSourceState(퓬P);
		transition퓬PTo퓬P.setTargetState(퓬P);
		transitionInitialStateToNeoTĂ.setSourceState(initialState);
		transitionInitialStateToNeoTĂ.setTargetState(neoTĂ);

	}

	/**
	*beginButtle
	*/
	protected abstract void beginButtle();
	/**
	*doConversation
	*/
	protected abstract void doConversation();
	/**
	*beginConversation
	*/
	protected abstract void beginConversation();
	/**
	*showResult
	*/
	protected abstract void showResult();
	/**
	*doButtle
	*/
	protected abstract void doButtle();
	/**
	*isNotButtleState
	*/
	protected abstract boolean isNotButtleState(Event e);
	/**
	*isEndInformation
	*/
	protected abstract boolean isEndInformation(Event e);
	/**
	*isDead
	*/
	protected abstract boolean isDead(Event e);
	/**
	*isNotDead
	*/
	protected abstract boolean isNotDead(Event e);
}
