/*
 * Created on 2004/05/24
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package matrix;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractSaviorBehavior
*/
public abstract class AbstractSaviorBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState b = factory.createCompositeState("b");
		CompositeState 퓬P = factory.createCompositeState("퓬P");
		CompositeState  = factory.createCompositeState("");
		CompositeState S = factory.createCompositeState("S");
		State terminalState = factory.createTerminalState();

		//actions
		Action doConversation = new Action() {
			public void doAction() {
				doConversation();
			}
			public String toString() {
				return "doConversation";
			}
		};
		Action showResult = new Action() {
			public void doAction() {
				showResult();
			}
			public String toString() {
				return "showResult";
			}
		};
		Action doButtle = new Action() {
			public void doAction() {
				doButtle();
			}
			public String toString() {
				return "doButtle";
			}
		};

		//guard-conditions
		GuardCondition isNotButtleState = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isNotButtleState(e);
			}
		};
		GuardCondition isDead = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isDead(e);
			}
		};
		GuardCondition isButtleInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isButtleInformation(e);
			}
		};
		GuardCondition isNotDead = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isNotDead(e);
			}
		};

		//transitions
		Transition transitionInitialStateTo = factory.createTransition();
		Transition transitionTob = factory.createTransition();
		Transition transition퓬PTo퓬P = factory.createTransition();
		Transition transitionbTob = factory.createTransition();
		Transition transitionSToTerminalState = factory.createTransition();
		Transition transitionbTo퓬P = factory.createTransition();
		Transition transition퓬PToS = factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(b);
		this.addState(퓬P);
		this.addState();
		this.addState(S);
		this.addTerminalState(terminalState);

		//transitions setting
		transitionTob.setEvent(ChannelEvent.class);
		transitionTob.addAction(doConversation);
		transition퓬PTo퓬P.setEvent(ChannelEvent.class);
		transition퓬PTo퓬P.setGuardCondition(isNotDead);
		transition퓬PTo퓬P.addAction(doButtle);
		transitionbTob.setEvent(ChannelEvent.class);
		transitionbTob.setGuardCondition(isNotButtleState);
		transitionbTob.addAction(doConversation);
		transitionSToTerminalState.addAction(showResult);
		transitionbTo퓬P.setEvent(ChannelEvent.class);
		transitionbTo퓬P.setGuardCondition(isButtleInformation);
		transitionbTo퓬P.addAction(doButtle);
		transition퓬PToS.setEvent(ChannelEvent.class);
		transition퓬PToS.setGuardCondition(isDead);

		//connection of transitions
		transitionInitialStateTo.setSourceState(initialState);
		transitionInitialStateTo.setTargetState();
		transitionTob.setSourceState();
		transitionTob.setTargetState(b);
		transition퓬PTo퓬P.setSourceState(퓬P);
		transition퓬PTo퓬P.setTargetState(퓬P);
		transitionbTob.setSourceState(b);
		transitionbTob.setTargetState(b);
		transitionSToTerminalState.setSourceState(S);
		transitionSToTerminalState.setTargetState(terminalState);
		transitionbTo퓬P.setSourceState(b);
		transitionbTo퓬P.setTargetState(퓬P);
		transition퓬PToS.setSourceState(퓬P);
		transition퓬PToS.setTargetState(S);

	}

	/**
	*doConversation
	*/
	protected abstract void doConversation();
	/**
	*showResult
	*/
	protected abstract void showResult();
	/**
	*doButtle
	*/
	protected abstract void doButtle();
	/**
	*isNotButtleState
	*/
	protected abstract boolean isNotButtleState(Event e);
	/**
	*isDead
	*/
	protected abstract boolean isDead(Event e);
	/**
	*isButtleInformation
	*/
	protected abstract boolean isButtleInformation(Event e);
	/**
	*isNotDead
	*/
	protected abstract boolean isNotDead(Event e);
}
