 /*
 * MatrixModel.java
 */
package matrix;

import org.boxed_economy.besp.container.BESPContainer;
import org.boxed_economy.besp.container.BESPPlugin;
import org.boxed_economy.besp.model.ModelContainer;
import org.boxed_economy.besp.model.fmfw.AgentType;
import org.boxed_economy.besp.model.fmfw.GoodsType;
import org.boxed_economy.besp.model.fmfw.BehaviorType;
import org.boxed_economy.besp.model.fmfw.InformationType;
import org.boxed_economy.besp.model.fmfw.RelationType; 

/**
 * Model for Boxed Economy Foundation Model Framework
 *
 * @generated modifiable
 * @version $$Id: MatrixModel.java,v 1.3 2004/06/01 15:44:07 samurai Exp $$
 */
public class MatrixModel implements BESPPlugin {
	
	public static AgentType AGENTTYPE_Smith;
	public static AgentType AGENTTYPE_Neo;
	public static BehaviorType BEHAVIORTYPE_CopyBehavior;
	public static BehaviorType BEHAVIORTYPE_SaviorBehavior;
	public static RelationType RELATIONTYPE_ButtleRelation;
	
	public static InformationType INFORMATIONTYPE_EndInformation;
	
	public static InformationType INFORMATIONTYPE_ButtleInformation;
	
	public static InformationType INFORMATIONTYPE_LifeInformation;
	
	public static InformationType INFORMATIONTYPE_TargetInformation;
	public static GoodsType GOODSTYPE_Life;
	
	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	public static void initializePlugin(BESPContainer container) {
		installTypes(container);
		buildStructure(container);
		setPriority(container);
	}

	/** 
	* This method will be modified automatically by Model Editor
	*
	* @generated
	*/
	private static void installTypes(BESPContainer container) {
		//Get the model container  
		ModelContainer modelContainer = container.getModelContainer();
		
		AGENTTYPE_Smith=modelContainer.installAgentType("matrix.Smith");
		AGENTTYPE_Neo=modelContainer.installAgentType("matrix.Neo");
		BEHAVIORTYPE_CopyBehavior=modelContainer.installBehaviorType("matrix.CopyBehavior");
		BEHAVIORTYPE_SaviorBehavior=modelContainer.installBehaviorType("matrix.SaviorBehavior");
		RELATIONTYPE_ButtleRelation=modelContainer.installRelationType("matrix.ButtleRelation");
		INFORMATIONTYPE_EndInformation=modelContainer.installInformationType("matrix.EndInformation");
		INFORMATIONTYPE_ButtleInformation=modelContainer.installInformationType("matrix.ButtleInformation");
		INFORMATIONTYPE_LifeInformation=modelContainer.installInformationType("matrix.LifeInformation");
		INFORMATIONTYPE_TargetInformation=modelContainer.installInformationType("matrix.TargetInformation");
		GOODSTYPE_Life=modelContainer.installGoodsType("matrix.Life");
	}

	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	private static void buildStructure(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
	}

	/** 
	* Set priority 
	*
	* @generated modifiable
	*/	
	private static void setPriority(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
		//:TODO set priority
	}
}